package tr.test;

import java.io.File;
import java.io.StringWriter;
import org.apache.http.HttpEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.ContentType;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.entity.mime.MultipartEntityBuilder;
import org.apache.http.impl.client.HttpClientBuilder;
import org.apache.http.entity.mime.content.FileBody;
import org.apache.http.entity.mime.content.StringBody;
import org.apache.http.impl.client.BasicResponseHandler;
import org.apache.http.client.ResponseHandler;
import java.io.IOException;
import org.json.JSONObject;
import org.json.JSONWriter;

/**
 * Record Match
 * Sample
 **/

public class HTTPClientRecordMatchPost {

	public static void main(String[] args) throws Exception {

		if(args.length < 2) {
			System.out.println("Please enter unique access key as 1st command line parameter, filename as 2nd");
			System.exit(-1);
		}
		try {

			// create HTTP client
			CloseableHttpClient httpClient = HttpClientBuilder.create().build();

		//  specify end-point URL 
			HttpPost httppost = new HttpPost("https://api.thomsonreuters.com/permid/match/file"); 

			FileBody file = new FileBody(new File(args[1]));

			//curl "https://api.thomsonreuters.com/permid/match/file" -H "X-AG-Access-Token:33CpiIRai3nqQjEAEuQ05n1sIHg2Fum0" 
			// -H "x-openmatch-numberOfMatchesPerRecord: 1" -H "x-openmatch-datatype: Organization" -F "file=@.\exampleRM.csv"

			//create HTTP entity to post the required file
			HttpEntity reqEntity = MultipartEntityBuilder.create()
					.addPart("file", file)
					.build();

			httppost.setEntity(reqEntity);        

			// set required headers
			httppost.setHeader("x-openmatch-numberOfMatchesPerRecord", "1");
			httppost.setHeader("X-AG-Access-Token", args[0]);
			httppost.setHeader("x-openmatch-dataType", "Organization");

			ResponseHandler<String> responseHandler=new BasicResponseHandler();

			// execute
			String strResponse = httpClient.execute(httppost, responseHandler);
			JSONObject jsonResponse=new JSONObject(strResponse);
			
			// pretty-print json response
			int spacesToIndentEachLevel = 2;
			System.out.println("JSON response:\n"+jsonResponse.toString(spacesToIndentEachLevel));
			
			//close on client
			httpClient.close();       
			
		} catch (IOException e) {

			System.err.println(e.getMessage());
			e.printStackTrace(System.err);

		}
	}
}
